import { PropsWithMetadata } from '@highlight-ui/utils-commons';
import * as React from 'react';
import { ReactDatePickerRawProps } from './ReactDatePickerRaw/ReactDatePickerRaw';
declare type TMonthSelectPluginOptions = {
    shorthand: boolean;
    dateFormat: string;
    altFormat: string;
    theme: 'light' | 'dark';
};
export declare type MonthNavigationProps = Omit<ReactDatePickerRawProps, 'children'> & PropsWithMetadata<{
    /** Size variant of the component */
    size?: 'small' | 'medium';
    /** Callback to be called when the navigation input receives a focus event */
    onFocus?: () => void;
    /** Callback to be called when the navigation input receives a blur event */
    onBlur?: () => void;
    /** Options that will be passed to Flatpickr's [monthSelectPlugin](https://flatpickr.js.org/plugins/#monthselectplugin) */
    monthSelectPluginOptions?: TMonthSelectPluginOptions;
    /** Whether or not to display the current month button */
    showTodayButton?: boolean;
    /** Will be rendered as the trigger to navigate to current IRL month */
    todayText?: string;
    /** Allows providing a custom class name to the DIV element that surrounds the text */
    className?: string;
}>;
declare const MonthNavigation: React.FC<MonthNavigationProps>;
export default MonthNavigation;
