import * as React from 'react';
import { AvailableLocales } from '../sharedTypes';
export declare type ReactDatePickerRawProps = {
    /** Currently selected Date */
    selected?: Date | null | undefined;
    /** Callback to be called when the a new month is picked */
    onDateChange: (a: Date | null | undefined) => void;
    /** Format for the date */
    dateFormat?: string;
    /** Determines the language of the input */
    locale?: AvailableLocales;
    /** Starting value for date */
    initialDate?: Date;
    /** Whether to disable closing the month navigation when a date is selected */
    disableCloseOnSelectDate?: boolean;
    /** Whether to disable closing the month navigation when clicking outside the element */
    disableCloseOnClickOutside?: boolean;
    /** Whether to disable toggling the month navigation when clicking the input element */
    disableToggleOnClick?: boolean;
    /** Options that will be passed to [Flatpickr](https://flatpickr.js.org/options/) */
    flatpickrOptions?: Record<string, unknown>;
    /** Children of the element */
    children: (args: ChildrenRenderProps) => React.ReactNode;
    /** Position of the month navigation */
    position?: 'top' | 'bottom';
};
declare type State = {
    value: string;
};
declare type ChildrenRenderProps = {
    value: string;
    inputRef: React.ElementRef<any>;
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
};
export declare class ReactDatePickerRaw extends React.Component<ReactDatePickerRawProps, State> {
    datePicker: any;
    static defaultProps: {
        locale: string;
        selected: undefined;
        initialDate: undefined;
        position: undefined;
        disableCloseOnSelectDate: boolean;
        disableCloseOnClickOutside: boolean;
        disableToggleOnClick: boolean;
        dateFormat: string;
        flatpickrOptions: {};
    };
    inputRef: React.ElementRef<any>;
    constructor(props: ReactDatePickerRawProps);
    componentDidMount(): void;
    componentDidUpdate({ selected: prevSelected }: ReactDatePickerRawProps): void;
    componentWillUnmount(): void;
    setDateOnCalendarAndInput: (date: Date) => void;
    setDateValueWithFormat: (date: Date | null | undefined) => void;
    onInputChangeHandler: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onDateChangeHandler: (date: Date | null | undefined) => void;
    renderDatePicker: () => void;
    render(): React.ReactNode;
}
export {};
