import { Button } from '@highlight-ui/button';
import { Icon } from '@highlight-ui/icon';
import { useLocale } from '@highlight-ui/i18n';
import { parseMetadata } from '@highlight-ui/utils-commons';
import classnames from 'classnames';
import MonthSelectPlugin from 'flatpickr/dist/plugins/monthSelect';
import * as React from 'react';
import { useRef, useState, useCallback, useEffect } from 'react';
import Flatpickr from 'flatpickr';
import { German } from 'flatpickr/dist/l10n/de';
import { english } from 'flatpickr/dist/l10n/default';
import { Spanish } from 'flatpickr/dist/l10n/es';
import { French } from 'flatpickr/dist/l10n/fr';
import { Dutch } from 'flatpickr/dist/l10n/nl';
import { Italian } from 'flatpickr/dist/l10n/it';
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

/* global Reflect, Promise */

var extendStatics = function (d, b) {
  extendStatics = Object.setPrototypeOf || {
    __proto__: []
  } instanceof Array && function (d, b) {
    d.__proto__ = b;
  } || function (d, b) {
    for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
  };

  return extendStatics(d, b);
};

function __extends(d, b) {
  if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
  extendStatics(d, b);

  function __() {
    this.constructor = d;
  }

  d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

function __rest(s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}

var TEST_IDS = {
  MONTH_PICKER_INPUT: 'month-picker-input',
  MONTH_PICKER_TODAY_BUTTON: 'month-picker-today-button',
  MONTH_PICKER_PREVIOUS_BUTTON: 'month-picker-previous-button',
  MONTH_PICKER_NEXT_BUTTON: 'month-picker-next-button'
};
var styles = {
  "heading-xsmall": "MonthNavigation-module__09sZOBjs__v2-1-10",
  "heading-small": "MonthNavigation-module__4zYe0JiK__v2-1-10",
  "input": "MonthNavigation-module__scoQ8Qhh__v2-1-10",
  "small": "MonthNavigation-module__G6JwXf2U__v2-1-10",
  "heading-medium": "MonthNavigation-module__--fSIfoj__v2-1-10",
  "heading-large": "MonthNavigation-module__cAW8hUsy__v2-1-10",
  "heading-xlarge": "MonthNavigation-module__ZZBN3Ta6__v2-1-10",
  "medium": "MonthNavigation-module__P-cYq3B5__v2-1-10",
  "heading-2xl": "MonthNavigation-module__hgfk-ER7__v2-1-10",
  "body-small": "MonthNavigation-module__SYPx0eKT__v2-1-10",
  "body-base": "MonthNavigation-module__9bnL-EDk__v2-1-10",
  "body-large": "MonthNavigation-module__BNfWeXKe__v2-1-10",
  "body-strong-small": "MonthNavigation-module__k7vO7YMc__v2-1-10",
  "body-strong-base": "MonthNavigation-module__yw-cneVM__v2-1-10",
  "body-strong-large": "MonthNavigation-module__bQyHXUd7__v2-1-10",
  "page-heading": "MonthNavigation-module__yWKdtX-w__v2-1-10",
  "button": "MonthNavigation-module__4cSI0h2s__v2-1-10",
  "form-label": "MonthNavigation-module__D1PyhKYz__v2-1-10",
  "caption": "MonthNavigation-module__z3vbijDK__v2-1-10",
  "text-link-default": "MonthNavigation-module__utR4fhbx__v2-1-10",
  "text-link-hover": "MonthNavigation-module__GxE1LMYH__v2-1-10",
  "table-data-regular": "MonthNavigation-module__geuapD4q__v2-1-10",
  "table-data-bold": "MonthNavigation-module__4IdNESIx__v2-1-10",
  "wrapper": "MonthNavigation-module__Ekz8do0c__v2-1-10",
  "flexCenter": "MonthNavigation-module__PTPyppWY__v2-1-10",
  "navigationButton": "MonthNavigation-module__hhgmSEfw__v2-1-10",
  "todayButton": "MonthNavigation-module__yXOKqcMT__v2-1-10",
  "icon": "MonthNavigation-module__McleyzXX__v2-1-10"
};

var MonthNavigationInput =
/** @class */
function (_super) {
  __extends(MonthNavigationInput, _super);

  function MonthNavigationInput() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.ref = null;

    _this.handleRef = function (ref) {
      if (!ref) return;
      _this.ref = ref;
    };

    return _this;
  }

  MonthNavigationInput.prototype.render = function () {
    return /*#__PURE__*/React.createElement("input", __assign({}, this.props, {
      ref: this.handleRef
    }));
  };

  return MonthNavigationInput;
}(React.Component);

var defaultOptions = {
  locale: 'en-GB',
  initialDate: undefined,
  disableCloseOnSelectDate: false,
  disableCloseOnClickOutside: false,
  disableToggleOnClick: false,
  title: '',
  onTitleClick: function () {}
};
var defaultFlatPickrOption = {
  enableTime: false,
  inline: true,
  allowInput: false,
  prevArrow: '<i class="fas fa-chevron-left"></i>',
  nextArrow: '<i class="fas fa-chevron-right"></i>'
};
var POSITION = {
  BOTTOM: 'bottom',
  TOP: 'top'
};

var transformDateFormat = function (dateFormat) {
  if (typeof dateFormat === 'string') {
    return dateFormat.replace('DD', 'd').replace('MM', 'm').replace('YYYY', 'Y').replace('YY', 'y');
  }

  return dateFormat;
};

var customEnglish = __assign(__assign({}, english), {
  firstDayOfWeek: 1
});

var localeDictionary = {
  'en-GB': {
    locale: customEnglish
  },
  'de-DE': {
    locale: German
  },
  'es-ES': {
    locale: Spanish
  },
  'fr-FR': {
    locale: French
  },
  'nl-NL': {
    locale: Dutch
  },
  'it-IT': {
    locale: Italian
  }
};

var DatePicker =
/** @class */
function () {
  function DatePicker(node, options) {
    var _this = this;

    this._createCalendarWrapper = function () {
      var wrapper = document.createElement('div');
      wrapper.classList.add('personio-datepicker-wrapper');
      wrapper.appendChild(document.createElement('div'));

      if (wrapper.firstChild) {
        wrapper.firstChild.appendChild(document.createElement('div'));
      }

      return wrapper;
    };

    this._findNodeParent = function () {
      var wrapper = _this._node.parentNode;
      wrapper.classList.add('personio-datepicker-input-wrapper');
      return wrapper;
    };

    this._setCalendarWrapperPosition = function () {
      if (_this._position === POSITION.BOTTOM) {
        return;
      }

      var calendarWrapperInfo = _this._calendarWrapper.getBoundingClientRect();

      var nodeParentInfo = _this._nodeParent.getBoundingClientRect();

      if (_this._position === POSITION.TOP) {
        _this._calendarWrapper.style.top = '';
        _this._calendarWrapper.style.bottom = nodeParentInfo.height + "px";
        return;
      }

      if (calendarWrapperInfo.bottom >= window.innerHeight) {
        _this._calendarWrapper.style.top = '';
        _this._calendarWrapper.style.bottom = nodeParentInfo.height + "px";
      }
    };

    this._resetCalendarWrapperPosition = function () {
      var nodeParentInfo = _this._nodeParent.getBoundingClientRect();

      _this._calendarWrapper.style.top = nodeParentInfo.height + "px";
      _this._calendarWrapper.style.bottom = '';
    };

    this._addEventListeners = function () {
      if (!_this._option.disableToggleOnClick) {
        _this._node.addEventListener('click', _this._openDatePicker);

        _this._node.addEventListener('focus', _this._openDatePicker);
      }

      if (!_this._option.disableCloseOnClickOutside) {
        window.document.addEventListener('click', _this._clickOutsideHandler);
      }
    };

    this._clickOutsideHandler = function (_a) {
      var target = _a.target;
      var targetElement = target;

      do {
        if (_this._node === targetElement || _this._calendarWrapper === targetElement) {
          return;
        } // typecasting to prevent flow type checking error


        targetElement = targetElement.parentNode;
      } while (targetElement);

      _this._closeDatePicker();
    };

    this._openDatePicker = function () {
      _this._calendarWrapper.classList.add('show');

      _this._setCalendarWrapperPosition();

      if (_this._node !== document.activeElement) {
        _this._node.focus();
      }
    };

    this._closeDatePicker = function () {
      _this._calendarWrapper.classList.remove('show');

      _this._resetCalendarWrapperPosition();
    };

    this.toggleDatePicker = function () {
      if (_this._calendarWrapper.classList.contains('show')) {
        _this._closeDatePicker();
      } else {
        _this._openDatePicker();
      }
    };

    this.destroy = function () {
      if (!_this._option.disableToggleOnClick) {
        _this._node.removeEventListener('click', _this._openDatePicker);

        _this._node.removeEventListener('focus', _this._openDatePicker);
      }

      if (!_this._option.disableCloseOnClickOutside) {
        window.document.removeEventListener('click', _this._clickOutsideHandler);
      }

      _this._flatPickrInstance.destroy();

      _this._nodeParent.removeChild(_this._calendarWrapper);
    };

    var optionsWithDefault = __assign(__assign({}, defaultOptions), options);

    if (node) {
      var initialDate = optionsWithDefault.initialDate,
          locale = optionsWithDefault.locale,
          onChange_1 = optionsWithDefault.onChange,
          disableCloseOnSelectDate_1 = optionsWithDefault.disableCloseOnSelectDate,
          disableCloseOnClickOutside = optionsWithDefault.disableCloseOnClickOutside,
          disableToggleOnClick = optionsWithDefault.disableToggleOnClick,
          position = optionsWithDefault.position,
          restOption = __rest(optionsWithDefault, ["initialDate", "locale", "onChange", "disableCloseOnSelectDate", "disableCloseOnClickOutside", "disableToggleOnClick", "position"]);

      this._node = node;
      this._nodeParent = this._findNodeParent();
      this._calendarWrapper = this._createCalendarWrapper();

      this._nodeParent.appendChild(this._calendarWrapper);

      var onChangeModified = function (dateArray) {
        if (!disableCloseOnSelectDate_1) {
          _this._closeDatePicker();
        }

        var date = Array.isArray(dateArray) ? dateArray[0] : undefined;
        onChange_1(date);
      };

      var finalOption = __assign(__assign(__assign(__assign({}, defaultFlatPickrOption), restOption), localeDictionary[locale]), {
        onChange: onChangeModified
      });

      this._option = {
        disableToggleOnClick: disableToggleOnClick,
        disableCloseOnClickOutside: disableCloseOnClickOutside
      }; // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore Flatpicker does not have a "void" return type

      this._flatPickrInstance = new Flatpickr(this._calendarWrapper.firstChild, finalOption);

      if (initialDate instanceof Date) {
        this._flatPickrInstance.setDate(initialDate);
      }

      this._position = position;

      this._addEventListeners();
    }
  }

  return DatePicker;
}();

var ReactDatePickerRaw =
/** @class */
function (_super) {
  __extends(ReactDatePickerRaw, _super);

  function ReactDatePickerRaw(props) {
    var _this = _super.call(this, props) || this;

    _this.inputRef = /*#__PURE__*/React.createRef();

    _this.setDateOnCalendarAndInput = function (date) {
      _this.setDateValueWithFormat(date);

      var TRIGGER_ONCHANGE_FOR_PLUGINS = true;

      _this.datePicker._flatPickrInstance.setDate(date, TRIGGER_ONCHANGE_FOR_PLUGINS);
    };

    _this.setDateValueWithFormat = function (date) {
      var dateFormat = _this.props.dateFormat;
      var transformedDateFormat = transformDateFormat(dateFormat);

      _this.setState({
        value: _this.datePicker._flatPickrInstance.formatDate(date, transformedDateFormat)
      });
    };

    _this.onInputChangeHandler = function (e) {
      if (e.target instanceof HTMLInputElement) {
        _this.setState({
          value: e.target.value
        }, function () {
          var value = _this.state.value;
          var _a = _this.props,
              dateFormat = _a.dateFormat,
              onDateChange = _a.onDateChange;
          var isValidDate = value.length === (dateFormat ? dateFormat.length : -1);
          var transformedDateFormat = transformDateFormat(dateFormat);

          var parsedDate = _this.datePicker._flatPickrInstance.parseDate(value, transformedDateFormat);

          var validatedDate = isValidDate ? parsedDate : undefined;
          onDateChange(validatedDate);

          _this.datePicker._flatPickrInstance.setDate(validatedDate);
        });
      }
    };

    _this.onDateChangeHandler = function (date) {
      var onDateChange = _this.props.onDateChange;

      _this.setDateValueWithFormat(date);

      onDateChange(date);
    };

    _this.renderDatePicker = function () {
      var _a = _this.props,
          flatpickrOptions = _a.flatpickrOptions,
          locale = _a.locale,
          initialDate = _a.initialDate,
          disableCloseOnSelectDate = _a.disableCloseOnSelectDate,
          disableCloseOnClickOutside = _a.disableCloseOnClickOutside,
          disableToggleOnClick = _a.disableToggleOnClick,
          position = _a.position;

      var options = __assign(__assign({}, flatpickrOptions), {
        locale: locale,
        initialDate: initialDate,
        disableCloseOnSelectDate: disableCloseOnSelectDate,
        disableCloseOnClickOutside: disableCloseOnClickOutside,
        disableToggleOnClick: disableToggleOnClick,
        position: position,
        onChange: _this.onDateChangeHandler
      });

      if (_this.datePicker) {
        _this.datePicker.destroy();
      } // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore migrate the LegacyRef so it will be type checked


      _this.datePicker = new DatePicker(_this.inputRef.current.ref, options);
    };

    _this.state = {
      value: ''
    };
    return _this;
  }

  ReactDatePickerRaw.prototype.componentDidMount = function () {
    this.renderDatePicker();
    var _a = this.props,
        initialDate = _a.initialDate,
        selected = _a.selected;

    if (initialDate instanceof Date) {
      this.setDateValueWithFormat(initialDate);
    }

    if (selected instanceof Date) {
      this.setDateOnCalendarAndInput(selected);
    }
  };

  ReactDatePickerRaw.prototype.componentDidUpdate = function (_a) {
    var prevSelected = _a.selected;
    var selected = this.props.selected;

    if (selected instanceof Date && typeof prevSelected === 'undefined' || selected instanceof Date && prevSelected instanceof Date && selected.toString() !== prevSelected.toString()) {
      this.setDateOnCalendarAndInput(selected);
    }
  };

  ReactDatePickerRaw.prototype.componentWillUnmount = function () {
    this.datePicker.destroy();
  };

  ReactDatePickerRaw.prototype.render = function () {
    var children = this.props.children;
    var value = this.state.value;
    return children({
      value: value,
      inputRef: this.inputRef,
      onChange: this.onInputChangeHandler
    });
  }; // eslint-disable-next-line react/static-property-placement


  ReactDatePickerRaw.defaultProps = {
    locale: 'en-GB',
    selected: undefined,
    initialDate: undefined,
    position: undefined,
    disableCloseOnSelectDate: false,
    disableCloseOnClickOutside: false,
    disableToggleOnClick: false,
    dateFormat: 'DD.MM.YYYY',
    flatpickrOptions: {}
  };
  return ReactDatePickerRaw;
}(React.Component);

var MEDIUM = 'medium';
var SMALL = 'small';
var SIZE_OFFSET = 0;

function getIconSize(size) {
  if (size === SMALL) {
    return 18;
  }

  return 24;
}

function getSize(size) {
  var _a;

  return _a = {}, _a[styles.small] = size === SMALL, _a[styles.medium] = size === MEDIUM, _a;
}

function notCurrentMonth(date) {
  var today = new Date();
  if (date.getFullYear() !== today.getFullYear()) return true;
  return date.getMonth() !== today.getMonth();
}

function getFirstDayOfCurrentMonth() {
  var today = new Date();
  return new Date(today.getFullYear(), today.getMonth(), 1);
}

var MonthNavigation = function (_a) {
  var _b = _a.size,
      size = _b === void 0 ? MEDIUM : _b,
      selected = _a.selected,
      onFocus = _a.onFocus,
      onBlur = _a.onBlur,
      metadata = _a.metadata,
      _c = _a.showTodayButton,
      showTodayButton = _c === void 0 ? true : _c,
      _d = _a.todayText,
      todayText = _d === void 0 ? 'Today' : _d,
      // datepicker props
  _e = _a.dateFormat,
      // datepicker props
  dateFormat = _e === void 0 ? 'F YYYY' : _e,
      _f = _a.flatpickrOptions,
      flatpickrOptions = _f === void 0 ? {} : _f,
      propsLocale = _a.locale,
      initialDate = _a.initialDate,
      onDateChange = _a.onDateChange,
      _g = _a.disableCloseOnSelectDate,
      disableCloseOnSelectDate = _g === void 0 ? false : _g,
      _h = _a.disableCloseOnClickOutside,
      disableCloseOnClickOutside = _h === void 0 ? false : _h,
      _j = _a.disableToggleOnClick,
      disableToggleOnClick = _j === void 0 ? false : _j,
      _k = _a.monthSelectPluginOptions,
      monthSelectPluginOptions = _k === void 0 ? {
    shorthand: true
  } : _k;
  var prevSelected = useRef();
  var appLocale = useLocale().locale;
  var locale = propsLocale || appLocale || 'en-GB';

  var _l = useState(initialDate || getFirstDayOfCurrentMonth()),
      date = _l[0],
      setDate = _l[1];

  var handleDateChange = React.useCallback(function (newDate) {
    setDate(newDate);
    onDateChange(newDate);
  }, [setDate, onDateChange]);
  var decreaseDate = useCallback(function () {
    if (date) {
      var newDate = new Date(date.getTime());
      newDate.setMonth(newDate.getMonth() - 1);
      setDate(newDate);
      onDateChange(newDate);
    }
  }, [onDateChange, setDate, date]);
  var increaseDate = useCallback(function () {
    if (date) {
      var newDate = new Date(date.getTime());
      newDate.setMonth(newDate.getMonth() + 1);
      setDate(newDate);
      onDateChange(newDate);
    }
  }, [onDateChange, setDate, date]);
  var onTodayClick = useCallback(function (e) {
    var newDate = getFirstDayOfCurrentMonth();
    setDate(newDate);
    onDateChange(newDate);
    window.document.activeElement.blur();

    if (e) {
      e.preventDefault();
    }
  }, [onDateChange, setDate]);
  useEffect(function () {
    if (!selected) {
      return;
    }

    if (!prevSelected.current || selected.toString() !== prevSelected.current) {
      setDate(selected);
    }

    prevSelected.current = selected.toString();
  }, [selected]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ReactDatePickerRaw, {
    onDateChange: handleDateChange,
    dateFormat: dateFormat,
    selected: date,
    locale: locale,
    initialDate: initialDate,
    disableCloseOnSelectDate: disableCloseOnSelectDate,
    disableCloseOnClickOutside: disableCloseOnClickOutside,
    disableToggleOnClick: disableToggleOnClick,
    flatpickrOptions: __assign(__assign({}, flatpickrOptions), {
      plugins: [MonthSelectPlugin(__assign({}, monthSelectPluginOptions))]
    })
  }, function (_a) {
    var value = _a.value,
        inputRef = _a.inputRef,
        onChange = _a.onChange;
    return /*#__PURE__*/React.createElement("div", __assign({}, parseMetadata(metadata), {
      className: styles.wrapper
    }), /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement("button", {
      type: "button",
      "aria-label": "Previous Month",
      onClick: decreaseDate,
      className: styles.navigationButton,
      "data-test-id": TEST_IDS.MONTH_PICKER_PREVIOUS_BUTTON
    }, /*#__PURE__*/React.createElement(Icon, {
      name: "angle-left",
      size: getIconSize(size),
      className: styles.icon
    })), /*#__PURE__*/React.createElement("button", {
      type: "button",
      "aria-label": "Next Month",
      onClick: increaseDate,
      className: styles.navigationButton,
      "data-test-id": TEST_IDS.MONTH_PICKER_NEXT_BUTTON
    }, /*#__PURE__*/React.createElement(Icon, {
      name: "angle-right",
      size: getIconSize(size),
      className: styles.icon
    })), /*#__PURE__*/React.createElement(MonthNavigationInput // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore refactoring ReactDatePickerRaw not to use LegacyRef is needed
    , {
      // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore refactoring ReactDatePickerRaw not to use LegacyRef is needed
      ref: inputRef,
      value: value,
      type: "text",
      onChange: onChange,
      onFocus: onFocus,
      onBlur: onBlur,
      size: value.length + SIZE_OFFSET,
      className: classnames(styles.input, getSize(size)),
      "data-test-id": TEST_IDS.MONTH_PICKER_INPUT
    })), showTodayButton && (!date || notCurrentMonth(date)) && /*#__PURE__*/React.createElement(Button, {
      onClick: onTodayClick,
      variant: "tertiary",
      className: styles.todayButton,
      "data-test-id": TEST_IDS.MONTH_PICKER_TODAY_BUTTON
    }, todayText));
  }));
};

export { MonthNavigation };
//# sourceMappingURL=index.js.map
